require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Context"
import "android.media.AudioManager"

layout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  {
    GridView,
    id = "grid",
    numColumns = 1,
    layout_width = "fill",
    layout_height = "fill",
  }
}

items = {
  "Media Volume Slider",
  "Call Volume Slider",
  "Alarm Volume Slider",
  "Accessibility Volume Slider",
  "Notification Volume Slider",
  "Ringtone Volume Slider",
}

dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))
dlg.setTitle("Volume Controller")
dlg.setButton("Close", nil)
dlg.show()

grid.onItemClick = function(l, v)
  local audioManager = this.getSystemService(Context.AUDIO_SERVICE)
  
  if v.text == "Media Volume Slider" then
    showVolumeSlider(audioManager, AudioManager.STREAM_MUSIC, "Media Volume")
  elseif v.text == "Call Volume Slider" then
    showVolumeSlider(audioManager, AudioManager.STREAM_VOICE_CALL, "Call Volume")
  elseif v.text == "Alarm Volume Slider" then
    showVolumeSlider(audioManager, AudioManager.STREAM_ALARM, "Alarm Volume")
  elseif v.text == "Accessibility Volume Slider" then
    showVolumeSlider(audioManager, AudioManager.STREAM_ACCESSIBILITY, "Accessibility Volume")
  elseif v.text == "Notification Volume Slider" then
    showVolumeSlider(audioManager, AudioManager.STREAM_NOTIFICATION, "Notification Volume")
  elseif v.text == "Ringtone Volume Slider" then
    showVolumeSlider(audioManager, AudioManager.STREAM_RING, "Ringtone Volume")
  end
end

-- Function to show volume sliders
function showVolumeSlider(audioManager, streamType, title)
  local maxVolume = audioManager.getStreamMaxVolume(streamType)
  local currentVolume = audioManager.getStreamVolume(streamType)

  local sliderLayout = {
    LinearLayout,
    orientation = "vertical",
    layout_width = "fill",
    layout_height = "fill",
    {
      TextView,
      text = title,
      layout_width = "fill",
      layout_height = "wrap",
      gravity = "center",
    },
    {
      SeekBar,
      id = "volumeSlider",
      max = maxVolume,
      progress = currentVolume,
      layout_width = "fill",
      layout_height = "wrap",
    }
  }

  local volumeDlg = LuaDialog(this)
  volumeDlg.View = loadlayout(sliderLayout)
  volumeDlg.setTitle(title)
  volumeDlg.setButton("Close", nil)
  volumeDlg.show()

  volumeSlider.setOnSeekBarChangeListener{
    onProgressChanged = function(seekBar, progress)
      audioManager.setStreamVolume(streamType, progress, AudioManager.FLAG_SHOW_UI)
      local volumePercentage = math.floor((progress / maxVolume) * 100)
      service.speak(tostring(volumePercentage) .. "% " .. title)
    end
  }
end